import random as r
import argparse

beg = ["a","e","i","o","u","ba","be","bi","bo","bu","by","y","da","de","di","do","du","dy","fa","fi","fo","fe","fu","ga","ge","gi","go","gu","ka","ke","ki","ko","ku","ky","ma","me","mi","mo","mu","na","ne","ni","no","nu","pa","pe","pi","po","pu","ra","re","ri","ro","ru","ry","sa","se","si","so","su","ta","te","ti","to","tu","ty","wa","we","wi","wo","wy","za","ze","zi","zo","zu","zy"]
mid = beg + ["l","x","n","r"]

def binarize(num, l=None):
    r = bin(num)[2:]
    try:
        l = int(l)
    except:
        l = None
    if l != None:
        while len(r) < l:
            r = "0" + r
    return r

def gen_name(length=None, minimum=3):
    maximum = 8
    if length == None:
        lgt = r.randint(minimum,maximum)
    else:
        if length > maximum:
            length = maximum
            print("Maximum name length is 8.")
        lgt = length
    morae = []
    while len("".join(morae)) < lgt:
        if len(morae) == 0:
            mora = r.choice(beg)
            morae.append(mora[0].upper() + mora[1:])
        else:
            mora = r.choice(mid)
            if morae[-1] == mora:
                mora = r.choice(mid)
            morae.append(mora)
    return "".join(morae)

class Plot:
    loc1 = ["friendly","hostile","derelict","airless","poison-filled/covered","overgrown","looted","burning","frozen","haunted","infested"]
    loc2 = ["asteroid","moon","space station","spaceship","ringworld","Dyson sphere","planet","Space Whale","pocket of folded space","time vortex","Reroll"]
    miss = ["to explore","to loot everything not bolted down too securely","to find the last group of kobolds who came here","to find a rumored secret weapon","to find a way to break someone else's secret weapon","to claim this place in the name of the Kobold Empire","to make friends","to rediscover lost technology","to find lost magical items","to find and defeat a powerful enemy"]
    prob = [
        {
            "id": 0,
            "name": "an Undead Sample Pack (swarm of zombies and skeletons)",
            "shortname": "undead",
            "stats": [0,5,2,6],
        },
        {
            "id": 1,
            "name": "a rival band of kobolds",
            "shortname": "kobold rivals",
            "stats": [3,3,4,4],
        },
        {
            "id": 2,
            "name": "a detachment from the Elf Armada",
            "shortname": "elves",
            "stats": [4,3,5,4],
        },
        {
            "id": 3,
            "name": "refugees with parasites. Big parasites",
            "shortname": "refugees",
            "stats": [2,4,0,0],
        },
        {
            "id": 4,
            "name": "an artificial intelligence bent on multi-world domination",
            "shortname": "AI",
            "stats": [4,1,6,3],
        },
        {
            "id": 5,
            "name": "robot spiders",
            "shortname": "spiders",
            "stats": [3,3,2,4],
        },
        {
            "id": 6,
            "name": "semi-intelligent metal eating slime",
            "shortname": "slime",
            "stats": [0,2,1,5],
        },
        {
            "id": 7,
            "name": "a living asteroid that intends to follow the kobolds home like the largest puppy",
            "shortname": "asteroid",
            "stats": [2,3,1,6],
        },
        {
            "id": 8,
            "name": "an old lich that wants everyone to stay off of their 'lawn'",
            "shortname": "lich",
            "stats": [5,2,6,3],
        },
        {
            "id": 9,
            "name": "elder gods hailing from the dark spaces between the stars",
            "shortname": "gods",
            "stats": [0,6,6,6],
        },
        {
            "id": 10,
            "name": "a Flying Brain Monster",
            "shortname": "Flying Brain Monster",
            "stats": [2,3,6,1],
        },
    ]
    
    def __init__(self):
        self.loc_desc = Plot.loc1[r.randint(0, len(Plot.loc1)-1)]
        self.locIndex = r.randint(0, len(Plot.loc2)-1)
        if self.locIndex == len(Plot.loc2) - 1:
            self.battlefield = 1
            self.locIndex = r.randint(0, len(Plot.loc2)-2)
            self.location = Plot.loc2[self.locIndex]
            if self.location[0].lower() in ["a","e","i","o","u"]:
                self.locart = 1
            else:
                self.locart = 0
        else:
            self.location = Plot.loc2[self.locIndex]
            self.battlefield = 0
            self.locart = 0
        self.missIndex = r.randint(0, len(Plot.miss)-1)
        self.oops = r.randint(1,12)
        if self.oops == 12:
            self.oops = 1 
        else:
            self.oops = 0
        self.mission = Plot.miss[r.randint(0, len(Plot.miss)-1)]
        self.probIndex = r.randint(0, len(Plot.prob)-1)
        self.problem = Plot.prob[self.probIndex]
        self.secProblem = None
        self.thirdProblem = None
        self.problem["name"] = gen_name()
        if self.problem["id"] == 3:
            self.secProblem = {"name": "Parasites", "shortname": "parasites", "stats": [3,4,2,3]}
        if self.problem["id"] == 10:
            self.secProbIndex = r.randint(0, len(Plot.prob)-2)
            self.secProblem = Plot.prob[self.secProbIndex]
            if self.secProbIndex == 3:
                self.thirdProblem = {"name": "Parasites", "shortname": "parasites", "stats": [3,4,2,3]}
        self.fullProblem = self.problem["name"]
        if self.secProblem and self.secProblem["name"] != "Parasites":
            self.fullProblem += " and its minion, " + self.secProblem["name"]


class Character:
    GADGETS = [ {"id": 0, "name": "Awesome Dagger of Sneak(?) Attacks", "description": "Yell 'Sneak Attack!' to count a mixed-success Body attack as a success.", "reusable": True},
                {"id": 1, "name": "Button of Uselessness", "description": f"This large, red button can be stuck onto any flat surface, horizontal, vertical, or otherwise. A short time after it has been placed, any character (friend or foe) nearby must succeed a Brains roll to avoid pressing the button. Pressing the button does nothing, but this action takes the place of anything that might otherwise be done during an Event if the Brains roll is failed. The button can be pressed {r.randint(1,6)} times before it breaks and no longer compels others to press it.", "reusable": False},
                {"id": 2, "name": "Encyclopedia of Stuff I Totally Knew", "description": "Add 2 points to the target number of any uncontested Brains roll, or 1 point to the target number of a contested Brains roll.", "reusable": True},
                {"id": 3, "name": "Medkit", "description": "Make a Brains/Order roll to restore 2 lost Body points, or 1 on a Mixed Success. If the character has medical training, restored Body points may be doubled.", "reusable": False},
                {"id": 4, "name": "Potion of Healing", "description": "Restore 1 lost Body point. Using counts as an Event but no roll is needed unless it’s contested.", "reusable": False},
                {"id": 5, "name": "Tinfoil Helm of Shielding", "description": "Count any Brains damage as a mixed success. If you take Body damage, roll 1d6; on a 6, the Helm is useless until you take a nap.", "reusable": True},
                {"id": 6, "name": "Handy Toothbrush", "description": "Scrub the Space Gunk off whatever object you're interacting with to turn a mixed Order success to make that object work into a full success.", "reusable": True},
                {"id": 7, "name": "Jar of ... Something", "description": "Throw it (Body/Chaos) at another character to make them spend an Event cleaning it off, or throw it at the floor to make a ten-foot circle of difficult terrain.", "reusable": False},
                {"id": 8, "name": "Pocket Sand!", "description": "Yell 'Pocket Sand!' to count a successful Body attack against you as a mixed success.", "reusable": False},
                {"id": 9, "name": "The Fabulous Grappling Hook", "description": "As an Event, instantly move 50 feet in any direction. (Make sure you have 50 feet available to move in or take 1 Body damage when you arrive short of that.)", "reusable": True},
                {"id": 10, "name": "Pocket Accordion", "description": "Make a Brains/Order or Brains/Chaos roll. On a success, any nearby opponent has -1 Brains during their next event. On a failure, everybody nearby, including you, has -1 Brains on their next event.", "reusable": True},
                {"id": 11, "name": "Cloak of Adsorption", "description": "The cloak starts out white. Whenever you are the target of a successful attack, the cloak becomes the color of whatever hit you. If your cloak is already the same color as whatever hit you, the attack becomes a mixed success and the cloak turns black and can no longer absorb colors. The cloak becomes white again after a nap.", "reusable": True},
                {"id": 12, "name": "Cloak of Absorption", "description": "The cloak starts out white. You can remove the cloak and lay it over difficult terrain to make it easy terrain; if the terrain is difficult because the ground is wet, the cloak becomes wet and the ground in that area becomes dry. The cloak dries out after a nap.", "reusable": True},
                {"id": 13, "name": "Cloak of Desorption", "description": "The cloak starts out black. As an Event, you can cause a gas to evaporate from the cloak, leaving it a dingy gray and healing 1 Body to anyone within ten feet of you. The cloak becomes black again after a nap.", "reusable": True},
                {"id": 14, "name": "Cloak of Food Portions", "description": "Wearing this cloak causes it to flare out at the base, making the wearer resemble a pyramid. In conversations regarding food the wearer can add +2 to Brains rolls when trying to convince others to alter their diets. This can be done once per nap. Considering how many large things tend to snack on kobolds, this has been found to actually be quite useful.", "reusable": True},
                {"id": 15, "name": "Huge Goggles", "description": "If you take Body damage, roll 1d6; on a 6, the lenses of the Goggles break until you take a nap.", "reusable": True},
    ]
    CAREERS = [ {"id": 0, "name": "Soldier/Guard"}, 
                {"id": 1, "name": "Pilot"}, 
                {"id": 2, "name": "Medic"}, 
                {"id": 3, "name": "Mechanic"}, 
                {"id": 4, "name": "Politician"}, 
                {"id": 5, "name": "Spellcaster"}, 
                {"id": 6, "name": "Performer"}, 
                {"id": 7, "name": "Historian"}, 
                {"id": 8, "name": "Spy"}, 
                {"id": 9, "name": "Cook"}, 
                {"id": 10, "name": "Cartographer"}, 
                {"id": 11, "name": "Inventor"}, 
                {"id": 12, "name": "Merchant"}
    ]

    def __init__(self):
        self.name = ""
        self.career = ""
        self.stats = []

    def generate(self):
        self.gen_name()
        self.gen_stats()
        self.gen_career()
        self.gen_gadget()

    def gen_name(self):
        self.name = gen_name()

    def gen_stats(self, n=12):
        if n < 0:
            print("Too few stat points!")
            return [0,0,0,0]
        stats = [0,0,0,0]
        points = n
        slots = [0,1,2,3]
        for _ in range(points):
            tgl = False
            while tgl == False:
                slt = r.choice(slots)
                if slt <= 1:
                    if stats[slt] == 6: continue
                    if stats[slt] == 5 and r.randint(0,1) != 1: continue
                else:
                    if stats[slt] == 6: continue
                    if stats[slt] > 2 and r.randint(0,stats[slt]-2) != 1: continue
                stats[slt] += 1
                tgl = True
        stats[3] = stats[3] + 1
        if stats[3] > 6:
            stats[3] = 6
        stats[2] = stats[2] + 1
        if stats[2] > 6:
            stats[2] = 6
        self.stats = stats

    def gen_career(self):
        self.career = r.choice(Character.CAREERS)

    def gen_gadget(self):
        self.gadget = r.choice(Character.GADGETS)

    def print_name(self, html=False):
        if html:
            charText = f"<h4>Name: {self.name} (Kobold {self.career})</h4>"
        else:
            charText = f"\nName: {self.name} (Kobold {self.career})"
        print(charText)

    def print(self, html=False):
        if html:
            out = (
                f"<div class='kobold'>\n"
                f"    <span class='koboldid'>\n"
                f"        <span class='koboldname'>{self.name}</span><br>\n"
                f"        <span class='koboldcareer'>Kobold {self.career.name}</span>\n"
                f"    </span>\n"
                f"    <br>\n"
                f"    <span class='koboldstats'>\n"
                f"        <ul>\n"
                f"            <li>Order: {self.stats[0]}</li>\n"
                f"            <li>Chaos: {self.stats[1]}</li>\n"
                f"            <li>Brain: {self.stats[2]}</li>\n"
                f"            <li>Body: {self.stats[3]}</li>\n"
                f"        </ul>\n"
                f"    </span>\n"
                f"    <br>\n"
                f"    <span class='koboldgadget'>\n"
                f"        <span class='koboldgadgetname'>{self.gadget['name']}</span><br>\n"
                f"        <span class='koboldgadgetdescription'>{self.gadget['description']}</span>\n"
                f"        <span class='koboldgadgetreuse'>{'<br>Reusable' if self.gadget['reusable'] else ''}</span>\n"
                f"    </span>"
                f"</div>\n"
            )
            print(out)
        else:
            self.print_name()
            print(f"Order: {self.stats[0]}")
            print(f"Chaos: {self.stats[1]}")
            print(f"Brain: {self.stats[2]}")
            print(f"Body: {self.stats[3]}")
            print(f"Gadget: {self.gadget['name']} ({self.gadget['description']}{'- Reusable' if self.gadget['reusable'] else ''})")

class Ship:
    NAME1 = ["Red","Orange","Yellow","Green","Blue","Violet","Dark","Light","Frenzied","Maniacal","Ancient"]
    NAME2 = ["Moon","Comet","Star","Saber","World-Eater","Dancer","Looter","Phlogiston","Fireball","Mecha","Raptor"]
    GQUAL = ["is stealthy & unarmored","is speedy & unarmored","is maneuverable & unarmored","is always repairable","is self-repairing","is flamboyant & speedy","is slow & armored","is flamboyant & armored","is hard to maneuver & armored","has Too Many Weapons!","has a prototype hyperdrive"]
    BQUAL = ["has an annoying AI","has inconveniently crossed circuits","has an unpredictable power source","drifts to the right","is haunted","was recently 'found' so the kobolds are unused to it","is too cold","has a constant odd smell","its interior design... changes","its water pressure shifts between slow drip and power wash","it leaves a visible smoke trail"]
    def __init__(self, name1=None, name2=None, gqual = None, bqual = None):
        self.name1 = name1 if name1 != None else r.choice(Ship.NAME1)
        self.name2 = name2 if name2 != None else r.choice(Ship.NAME2)
        self.gqual = gqual if gqual != None else r.choice(Ship.GQUAL)
        self.bqual = bqual if bqual != None else r.choice(Ship.BQUAL)
        self.fullname = f"{self.name1} {self.name2}"

    def print(self, html=False):
        if (html):
            shipText = f"<p>The <strong>{self.fullname}</strong> <span style='color: blue;'>{self.gqual}</span>, but <span style='color: red;'>{self.bqual}</span>.</p>\n"
        else:
            shipText = f"The {self.fullname} {self.gqual}, but {self.bqual}.\n"
        print(shipText)

class Campaign:
    ALPHABET = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz?- "
    NAMELETS = ['a', 'e', 'i', 'o', 'u', 'b', 'y', 'd', 'f', 'g', 'k', 'm', 'n', 'p', 'r', 's', 't', 'w', 'z', 'l', 'x']

    def __init__(self, n=None, makeChars=True, fromPW=False, pw=None):
        if fromPW == True:
            self.ship = None
            self.params. = None
            self.characters = None
            self.art = None
            self.decode_key(pw)
        else:
            n = 6 if n == None else n
            self.ship = Ship()
            self.params = Plot()
            self.params.problem["fullname"] = ""
            if self.params.problem["id"] in [1,2]:
                self.params.problem["fullname"] += " led by " + self.params.problem["name"]
            if self.params.problem["id"] in [4,7,8,10]:
                self.params.problem["fullname"] += " named " + self.params.problem["name"]
            if makeChars:
                self.characters = []
                for _ in range(n):
                    c = Character()
                    c.generate()
                    self.characters.append(c)
            self.art = "an" if self.params.loc_desc[0] in ["a","e","i","o","u"] else "a"

    def generate_key(self):
        """
            "PACKTA CTICS! ------- ------- ------- ------- ------- ------- ------- ------- ------- ------- ------- -------" should generate the Season 3 Pack Tactics crew.
            "JUSTIN BAILEY" and "NARPAS SWORD" should do something too.
            Key is analphanumeric string generated from a bitfield
            Bitfield is:
            Location 1: 7 bits
            Location 2: 7 bits
            Location Battlefield: 1 bit
            Mission: 7 bits
            Oops: 1 bit
            Problem 1: 7 bits
            Problem 1 name: 40 bits
            Problem 2: 7 bits
            Ship name 1: 7 bits
            Ship name 2: 7 bits
            Ship gqual: 7 bits
            Ship bqual: 7 bits
            Character 1 name: 40 bits
            Character 1 career: 7 bits
            Character 1 order: 3 bits
            Character 1 chaos: 3 bits
            Character 1 body: 3 bits
            Character 1 brain: 3 bits
            Character 1 gadget: 7 bits
            Character 2 name: 40 bits
            Character 2 career: 7 bits
            Character 2 order: 3 bits
            Character 2 chaos: 3 bits
            Character 2 body: 3 bits
            Character 2 brain: 3 bits
            Character 2 gadget: 7 bits
            Character 3 name: 40 bits
            Character 3 career: 7 bits
            Character 3 order: 3 bits
            Character 3 chaos: 3 bits
            Character 3 body: 3 bits
            Character 3 brain: 3 bits
            Character 3 gadget: 7 bits
            Character 4 name: 40 bits
            Character 4 career: 7 bits
            Character 4 order: 3 bits
            Character 4 chaos: 3 bits
            Character 4 body: 3 bits
            Character 4 brain: 3 bits
            Character 4 gadget: 7 bits
            Character 5 name: 40 bits
            Character 5 career: 7 bits
            Character 5 order: 3 bits
            Character 5 chaos: 3 bits
            Character 5 body: 3 bits
            Character 5 brain: 3 bits
            Character 5 gadget: 7 bits
            Character 6 name: 40 bits
            Character 6 career: 7 bits
            Character 6 order: 3 bits
            Character 6 chaos: 3 bits
            Character 6 body: 3 bits
            Character 6 brain: 3 bits
            Character 6 gadget: 7 bits
            104 for campaign
            396 for characters
            total 501
            11 remaining
        """
        self.key = ""
        l1 = bin(Plot.loc1.index(self.params.loc_desc))[2:]
        l2 = bin(Plot.loc2.index(self.params.location))[2:]
        lb = bin(self.params.battlefield)[2:]
        op = bin(self.params.oops)[2:]
        ms = bin(Plot.miss.index(self.params.mission))[2:]
        pb1 = bin(self.params.probIndex)[2:]
        if self.params.probIndex == 10:
            pb2 = bin(self.params.secProbIndex)[2:]
        else:
            pb2 = bin(127)[2:]
        pbname = "".join([bin(Campaign.NAMELETS.index(x.lower()))[2:] for x in self.params.problem["name"]])
        n1 = bin(Ship.NAME1.index(self.ship.name1))[2:]
        n2 = bin(Ship.NAME2.index(self.ship.name2))[2:]
        gq = bin(Ship.GQUAL.index(self.ship.gqual))[2:]
        bq = bin(Ship.BQUAL.index(self.ship.bqual))[2:]
        chars = {}
        i = 0
        for chct in self.characters:
            chars[i] = {
                "name": "".join([bin(Campaign.NAMELETS.index(x.lower()))[2:] for x in chct.name]),
                "career": bin(chct.career["id"])[2:],
                "order": bin(chct.stats[0])[2:],
                "chaos": bin(chct.stats[1])[2:],
                "body": bin(chct.stats[2])[2:],
                "brains": bin(chct.stats[3])[2:],
                "gadget": bin(chct.gadget["id"])[2:]
            }
            i += 1
        # print(chars)
        while len(l1) < 7:
            l1 = "0" + l1
        # print(f"Len(l1) = {len(l1)}")
        while len(l2) < 7:
            l2 = "0" + l2
        # print(f"Len(l2) = {len(l2)}")
        while len(ms) < 7:
            ms = "0" + ms
        # print(f"Len(ms) = {len(ms)}")
        while len(pb1) < 7:
            pb1 = "0" + pb1
        # print(f"Len(pb1) = {len(pb1)}")
        while len(pb2) < 7:
            pb2 = "0" + pb2
        # print(f"Len(pb2) = {len(pb2)}")
        while len(pbname) < 40:
            pbname = "0" + pbname
        # print(f"Len(pbname) = {len(pbname)}")
        while len(n1) < 7:
            n1 = "0" + n1
        # print(f"Len(n1) = {len(n1)}")
        while len(n2) < 7:
            n2 = "0" + n2
        # print(f"Len(n2) = {len(n2)}")
        while len(gq) < 7:
            gq = "0" + gq
        # print(f"Len(gq) = {len(gq)}")
        while len(bq) < 7:
            bq = "0" + bq
        # print(f"Len(bq) = {len(bq)}")
        self.key += l1 + l2 + lb + op + ms + pb1 + pb2 + pbname + n1 + n2 + gq + bq
        for k,chct in chars.items():
            while len(chct["name"]) < 40:
                chct["name"] = "0" + chct["name"]
            # print(f"Len(chct.name) = {len(chct['name'])}")
            while len(chct["career"]) < 7:
                chct["career"] = "0" + chct["career"]
            # print(f"Len(chct.career) = {len(chct['career'])}")
            while len(chct["order"]) < 3:
                chct["order"] = "0" + chct["order"]
            # print(f"Len(chct.order) = {len(chct['order'])}")
            while len(chct["chaos"]) < 3:
                chct["chaos"] = "0" + chct["chaos"]
            # print(f"Len(chct.chaos) = {len(chct['chaos'])}")
            while len(chct["body"]) < 3:
                chct["body"] = "0" + chct["body"]
            # print(f"Len(chct.body) = {len(chct['body'])}")
            while len(chct["brains"]) < 3:
                chct["brains"] = "0" + chct["brains"]
            # print(f"Len(chct.brains) = {len(chct['brains'])}")
            while len(chct["gadget"]) < 7:
                chct["gadget"] = "0" + chct["gadget"]
            # print(f"Len(chct.gadget) = {len(chct['gadget'])}")
            self.key += chct["name"] + chct["career"] + chct["order"] + chct["chaos"] + chct["body"] + chct["brains"] + chct["gadget"]
        # print(len(self.key))
        while len(self.key) < 509:
            self.key = self.key + "0"
        # print(len(self.key))
        self.okey = ""
        letters = []
        letter = []
        for bit in self.key:
            letter.append(bit)
            if len(letter) == 6:
                letters.append(Campaign.ALPHABET[int("".join(letter),2)])
                letter = []
        words = []
        word = []
        for lt in letters:
            word.append(lt)
            if len(word) == 6:
                words.append("".join(word))
                word = []
        words.append("".join(word))
        self.password = " ".join(words)
        # print(self.password)
        return self.password

    def decode_key(self, pw):
        """
        Repeating this here for the sake of convenience.
        Location 1: 7 bits
        Location 2: 7 bits
        Location Battlefield: 1 bit
        Mission: 7 bits
        Oops: 1 bit
        Problem 1: 7 bits
        Problem 1 name: 40 bits
        Problem 2: 7 bits
        Ship name 1: 7 bits
        Ship name 2: 7 bits
        Ship gqual: 7 bits
        Ship bqual: 7 bits
        Character 1 name: 40 bits
        Character 1 career: 7 bits
        Character 1 order: 3 bits
        Character 1 chaos: 3 bits
        Character 1 body: 3 bits
        Character 1 brain: 3 bits
        Character 1 gadget: 7 bits
        Character 2 name: 40 bits
        Character 2 career: 7 bits
        Character 2 order: 3 bits
        Character 2 chaos: 3 bits
        Character 2 body: 3 bits
        Character 2 brain: 3 bits
        Character 2 gadget: 7 bits
        Character 3 name: 40 bits
        Character 3 career: 7 bits
        Character 3 order: 3 bits
        Character 3 chaos: 3 bits
        Character 3 body: 3 bits
        Character 3 brain: 3 bits
        Character 3 gadget: 7 bits
        Character 4 name: 40 bits
        Character 4 career: 7 bits
        Character 4 order: 3 bits
        Character 4 chaos: 3 bits
        Character 4 body: 3 bits
        Character 4 brain: 3 bits
        Character 4 gadget: 7 bits
        Character 5 name: 40 bits
        Character 5 career: 7 bits
        Character 5 order: 3 bits
        Character 5 chaos: 3 bits
        Character 5 body: 3 bits
        Character 5 brain: 3 bits
        Character 5 gadget: 7 bits
        Character 6 name: 40 bits
        Character 6 career: 7 bits
        Character 6 order: 3 bits
        Character 6 chaos: 3 bits
        Character 6 body: 3 bits
        Character 6 brain: 3 bits
        Character 6 gadget: 7 bits
    """
    densePwd = pw.replace(" ", "")
    if densePwd == "PACKTACTICS!------------------------------------------------------------------------------------":
        # Create a campaign featuring the Season 3 Pack Tactics crew.
        return
    elif densePwd == "JUSTINBAILEY------------------------------------------------------------------------------------":
        # Create a random campaign, but everyone's Gadget is a leotard that somehow is also an environment suit
        return
    elif densePwd == "NARPASSWORD------------------------------------------------------------------------------------":
        # Create a random campaign, but all the kobolds' stats are set to 6
        return
    numPwd = []
    for c in densePwd:
        numPwd.append(Campaign.ALPHABET.index(c))
    bitPwd = [bin(x).replace("0b","") for x in numPwd]
    longBitPwd = []
    for word in bitPwd:
        longword = word
        while len(longword) < 6:
            longword = "0" + longword
        longBitPwd.append(longword)
    self.newBitfield = "".join(longBitPwd)
    print(self.newBitfield)
    return self.newBitfield


    def print_params(self, endc=" ", html=False):
        print(len(Plot.miss))
        st = ["Order:", "Chaos:", "Brains:", "Body:"]
        cst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.problem["stats"]]))])
        if self.params.oops == 1:
            oops = "...well, they weren't paying attention, so don't tell them, but they're supposed "
        else:
            oops = ""
        location = oops + self.params.location
        lines = [
            f"The Kobolds of the {self.ship.fullname}",
            f"have been sent out to {self.art} {self.params.loc_desc} {location}!",
            f"in order {self.params.mission}",
            f"but they're challenged by {self.params.fullProblem}!",
            f"The stats of the {self.params.problem['shortname']}",
            f"{cst}"
        ]
        if self.params.secProblem:
            mst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.secProblem["stats"]]))])
            lines.append(f"The stats of the {self.params.secProblem['shortname']}")
            lines.append(f"{mst}")
            if self.params.thirdProblem:
                pst = ", ".join([" ".join(y) for y in list(zip(st, [str(x) for x in self.params.thirdProblem["stats"]]))])
                lines.append(f"The stats of the {self.params.thirdProblem['shortname']}")
                lines.append("{pst}")
        if html:
            out = (
                f"<div id='theship' class='firstrow'>\n"
                f"    <span class='head'>The Ship</span>\n"
                f"    <span id='shipname'>\n"
                f"        The {self.ship.fullname}!\n"
                f"    </span>\n"
                f"    <br>\n"
                f"    <span id='shipquality1'>\n"
                f"        It {self.ship.gqual}...\n"
                f"    </span><br>\n"
                f"    <span id='shipquality2'>\n"
                f"        But {self.ship.bqual}!\n"
                f"    </span>\n"
                f"</div>\n"
                f"<div id='themission' class='firstrow'>\n"
                f"    <span class='head'>The Mission</span>\n"
                f"    <span id='missionloc'>\n"
                f"        The kobolds have been sent to {self.art} {self.params.loc_desc} {self.params.location}!\n"
                f"    </span><br>\n"
                f"    <span id='missiontarget'>\n"
                f"        in order {self.params.mission}\n"
                f"    </span>\n"
                f"</div>\n<br clear='all'>\n"
                f"<div id='theadversary' class='firstrow'>\n"
                f"    <span class='head'>The Adversary</span>\n"
                f"    They're challenged by <span id='advname'>{self.params.fullProblem}</span>!\n"
                f"    <br>\n"
                f"    <span id='problemstats'>\n"
                f"        The stats of the {self.params.problem['shortname']}:<br>\n"
                f"        {cst}\n"
                f"    </span>\n"
            )
            if self.params.secProblem:
                out += (
                    f"    <br><span id='secprobstats'>\n"
                    f"        The stats of the {self.params.secProblem['shortname']}:<br>\n"
                    f"        {mst}\n"
                    f"    </span>\n"
                )
                if self.params.thirdProblem:
                    out += (
                        f"    <br><span id='thirdprobstats'>\n"
                        f"        The stats of the {self.params.thirdProblem['shortname']}:<br>\n"
                        f"        {pst}\n"
                        f"    </span>\n"
                    )
            out += f"</div>\n"
            print(out)
            print(f"<br clear='all'>\n")
        else:
            print(f"{lines[0]} {lines[1]} {lines[2]} -- {lines[3]}")
            print(f"{lines[4]}: {lines[5]}")
            if self.params.secProblem:
                print(f"- {lines[6]}: {lines[7]}")
                if self.params.thirdProblem:
                    print(f"- - {lines[8]}: {lines[9]}")
            print()
            self.ship.print(html=html)

    def print_chars(self, html=False):
        if html:
            print(f"<div id='thekobolds'>\n")
            print(f"<span class='head'>The Kobolds</span>\n")
        else:
            print("The kobolds:")
        for k in self.characters:
            k.print(html=html)
        if html:
            print(f"</div>\n<br clear='all'>\n")

    def decode(self, pwd):
        pass

class Password:
    pass

if __name__ == "__main__":
    parser = argparse.ArgumentParser()
    group = parser.add_mutually_exclusive_group()
    group.add_argument("-c", "--campaign", help="print a full campaign block with N kobolds (default 6)", nargs="?", const=6, type=int, metavar="N")
    group.add_argument("-k", "--kobolds", help="print N kobolds", type=int, nargs="?", const=1, default=1, metavar="N")
    group.add_argument("-n", "--names", help="print N kobolds without stat blocks", nargs="?", const=1, type=int, metavar="N")
    group.add_argument("-p", "--params", help="print only the parameters of a campaign", action="store_true")
    group.add_argument("-s", "--ship", help="print only the ship name and description", action="store_true")
    group.add_argument("-pw", "--password", help="print the campaign defined by the submitted password", type=str, nargs="?", const=1, metavar="PW")
    parser.add_argument("--html", help="print in HTML instead of plain text", action="store_true")
    args = parser.parse_args()
    # print(args)
    html = True if args.html else False
    if args.password:
        pw = Password(args.password)
        # print(pw.newBitfield)
        cmp = Campaign(fromPW = True)
        cmp.decode(pw)
    elif args.campaign:
        cmp = Campaign(args.campaign)
        cmp.print_params(html=html)
        cmp.print_chars(html=html)
        print(cmp.generate_key())
    elif args.params:
        cmp = Campaign(makeChars=False)
        cmp.print_params(html=html)
    elif args.ship:
        ship = Ship()
        ship.print(html=html)
    elif args.names:
        for _ in range(args.names):
            c = Character()
            c.generate()
            c.print_name(html=html)
    else:
        for _ in range(args.kobolds):
            c = Character()
            c.generate()
            c.print(html=html)
